package com.bergerkiller.bukkit.nolagg.saving;

import java.lang.reflect.Field;
import java.util.Iterator;

import net.minecraft.server.Chunk;

public class DummyChunk extends Chunk {
	
	private Field fieldX;
	private Field fieldZ;
	public DummyChunk(DummyWorld world) throws Throwable {
		super(world, 0, 0);
		fieldX = Chunk.class.getDeclaredField("x");
		fieldZ = Chunk.class.getDeclaredField("z");
		fieldX.setAccessible(true);
		fieldZ.setAccessible(true);
		this.bukkitChunk = null;
	}

	@SuppressWarnings({"unchecked", "rawtypes"})
	public boolean load(Chunk chunk) {
		try {
			fieldX.set(this, chunk.x);
			fieldZ.set(this, chunk.z);	
			this.b = chunk.b;
			this.g = chunk.g;
			this.h = chunk.h;
			this.i = chunk.i;
			this.heightMap = chunk.heightMap;
			this.done = chunk.done;
			for (int i = 0; i < chunk.entitySlices.length; i++) {
				this.entitySlices[i].clear();
				this.entitySlices[i].addAll(chunk.entitySlices[i]);
			}
			this.tileEntities.clear();
			this.tileEntities.putAll(chunk.tileEntities);
			Iterator iter;
			net.minecraft.server.Entity e;
			for (int i = 0; i < this.entitySlices.length; i++) {
				iter = this.entitySlices[i].iterator();
				while (iter.hasNext()) {
					e = (net.minecraft.server.Entity) iter.next();
					if (e.dead || (int) e.locX >> 4 != this.x || (int) e.locZ >> 4 != this.z) iter.remove();
				}
			}
			return true;
		} catch (Throwable t) {
			t.printStackTrace();
			return false;
		}
	}
	
		
}
